<script setup lang="ts">
import { ref, onMounted } from "vue";
import { useQuasar } from "quasar";

import {
  checkPermission,
  checkPermissionList,
  checkPermissionCreate,
} from "@/utils/permissions";
import { useRouter } from "vue-router";
import { useCounterMixin } from "@/stores/mixin";
import { useTransferDataStore } from "@/modules/05_placement/store";
import http from "@/plugins/http";
import config from "@/app.config";

import type { QTableProps } from "quasar";
import type { PersonData } from "@/modules/05_placement/interface/index/Main";
import type { resData } from "@/modules/05_placement/interface/response/AppointMent";
import type { OpType } from "@/modules/05_placement/interface/response/Main";
import type { FormDataAppoint } from "@/modules/05_placement/interface/request/Main";

import DialogOrgSelectEmployee from "@/components/Dialogs/DialogOrgSelectEmployee.vue"; //เลือกหน่วยงาน
import Dialogbody from "@/modules/05_placement/components/AppointEmployee/DialogOrders.vue";

const $q = useQuasar();
const router = useRouter();
const store = useTransferDataStore();
const { statusText, filterOption } = useTransferDataStore();
const mixin = useCounterMixin(); //เรียกฟังก์ชันกลาง
const {
  showLoader,
  hideLoader,
  success,
  messageError,
  date2Thai,
  dialogRemove,
  onSearchDataTable,
  findOrgNameHtml,
  findOrgName,
} = mixin;

const status = ref<string>("");

const personalId = ref<string>("");
const modal = ref<boolean>(false); //แสดง popup ส่งไปออกคำสั่ง
const modalTree = ref<boolean>(false); //แสดง popup  เลือกหน่วยงานที่รับการปรับระดับชั้นงาน
const typeModal = ref<string>(""); //ประเภท popup ปรับระดับชั้นงาน,รับย้าย
const posType = ref<string>(""); //ตำแหน่งประเภท
const posLevel = ref<string>(""); //ระดับตำแหน่ง
const position = ref<string>(""); //ตำแหน่ง
const dataRows = ref<PersonData>();
const listRecevice = ref<resData[]>([]); //ข้อมูลรายการปรับระดับชั้นงานลูกจ้าง
const optionsType = ref<OpType[]>([]);
const type = ref<string>("");

// Table
const rows = ref<PersonData[]>([]); //รายการปรับระดับชั้นงานลูกจ้าง
const rowsData = ref<PersonData[]>([]); //รายการปรับระดับชั้นงานลูกจ้าง
const rows2 = ref<PersonData[]>([]); //รายการออกคำสั่ง
const rows2Data = ref<PersonData[]>([]); //รายการออกคำสั่ง
const filterKeyword = ref<string>(""); //คำค้นหารายการปรับระดับชั้นงานลูกจ้าง
const filterKeyword2 = ref<string>(""); //คำค้นหารายการออกคำสั่ง
const visibleColumns = ref<string[]>([
  "no",
  "citizenId",
  "fullname",
  "positionLevel",
  "positionNumberOld",
  "organizationNameOld",
  "organizationName",
  "dateOfBirth",
  "typeCommand",
  "createdAt",
  "status",
]);
const pagination = ref({
  sortBy: "createdAt",
  descending: true,
  page: 1,
  rowsPerPage: 10,
});
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "citizenId",
    align: "left",
    label: "เลขประจำตัวประชาชน",
    sortable: true,
    field: "citizenId",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "fullname",
    align: "left",
    label: "ชื่อ-นามสกุล",
    sortable: true,
    field: "fullname",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return `${
        row.firstName
          ? `${row.prefix ?? ""}${row.firstName ?? ""} ${row.lastName ?? ""}`
          : "-"
      }`;
    },
  },
  {
    name: "positionNumberOld",
    align: "left",
    label: "ตำแหน่งเลขที่เดิม",
    sortable: true,
    field: "positionNumberOld",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return row.positionNumberOld;
    },
  },
  {
    name: "positionLevel",
    align: "left",
    label: "ตำแหน่งประเภทเดิม",
    sortable: true,
    field: "positionLevel",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      let name = "";
      if (row.positionTypeOld && row.positionLevelOld) {
        name = `${row.positionTypeOld} (${row.positionLevelOld})`;
      } else if (row.positionTypeOld) {
        name = `${row.positionTypeOld}`;
      } else if (row.positionLevelOld) {
        name = `(${row.positionLevelOld})`;
      } else name = "-";
      return name;
    },
  },
  {
    name: "organizationNameOld",
    align: "left",
    label: "ตำแหน่ง/สังกัดเดิม",
    sortable: true,
    field: "organizationNameOld",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val, row) => {
      return `${row.organizationPositionOld.replace(/(.*)\s(.*)$/, "$1\n$2")}`;
    },
  },
  {
    name: "organizationName",
    align: "left",
    label: "ตำแหน่ง/หน่วยงานที่รับปรับระดับชั้นงาน-ย้าย",
    sortable: true,
    field: "organizationName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val, row) => {
      // return `${row.root} (${row.rootShortName}) ${row.nodeName} (${row.nodeShortName}${row.posMasterNo})`;
      return `${row.position !== null ? row.position : ""} ${
        row.posLevelName !== null ? `${row.posLevelName}` : ""
      } ${
        row.nodeShortName !== null
          ? `(${row.nodeShortName} ${row.posMasterNo})`
          : ""
      } ${findOrgName(row)}`;
    },
  },
  {
    name: "dateOfBirth",
    align: "left",
    label: "วัน/เดือน/ปี เกิด",
    sortable: true,
    field: "dateOfBirth",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return date2Thai(row.dateOfBirth);
    },
  },
  {
    name: "typeCommand",
    align: "left",
    label: "ประเภทคำสั่ง",
    sortable: true,
    field: "typeCommand",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (val: string) => {
      return val === "SLIP"
        ? "ปรับระดับชั้นงาน"
        : val === "MOVE"
        ? "ย้าย"
        : "-";
    },
  },
  {
    name: "createdAt",
    align: "left",
    label: "วันที่ดำเนินการ",
    sortable: true,
    field: "createdAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return date2Thai(row.createdAt);
    },
  },
  {
    name: "status",
    align: "left",
    label: "สถานะ",
    sortable: true,
    field: "status",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format(val, row) {
      return statusText(row.status);
    },
  },
]);

/** fetch รายการปรับระดับชั้นงานลูกจ้าง*/
async function fecthlistappointment() {
  showLoader();
  await http
    .get(config.API.appointEmployee() + `?status=${status.value}`)
    .then(async (res) => {
      let response = await res.data.result;
      listRecevice.value = response;
      rows.value = response;
      rowsData.value = response;
      //หารายชื่อส่งไปออกคำสั่ง
      const listData = rows.value.filter(
        (e: PersonData) =>
          e.root !== null &&
          e.status !== "REPORT" &&
          e.status !== "DONE" &&
          e.educationOld &&
          e.organizationPositionOld &&
          e.positionTypeOld &&
          e.positionLevelOld &&
          e.positionNumberOld &&
          e.positionDate
      );
      rows2.value = listData;
      rows2Data.value = listData;
      await onSearch();
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ยืนยันลบรายการปรับระดับชั้นงานลูกจ้าง
 * @param id รายการปรับระดับชั้นงานลูกจ้าง
 */
function clickDelete(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    await http
      .delete(config.API.appointEmployeeByid(id))
      .then(async () => {
        await fecthlistappointment();
        await success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * redialect รายละเอียดการปรับระดับชั้นงานลูกจ้าง
 * @param id  รายการปรับระดับชั้นงานลูกจ้าง
 */
function nextPage(id: string) {
  router.push({
    path: `appoint-employee/detail/${id}`,
  });
}

/** เปิด popup  ส่งไปออกคำสั่ง*/
function popup() {
  modal.value = true;
  filterKeyword2.value = "";
}

/** ปิด popup  ส่งไปออกคำสั่ง*/
function clickClose() {
  modal.value = false;
}

/**
 * เปิด popup เลือกหน่วยงาน
 * @param data ข้อมูลหน่วยงาน
 * @param type ประเภท ย้าย,ปรับ
 */
function openModalTree(data: PersonData, type: string) {
  typeModal.value = type;
  personalId.value = data.id;
  dataRows.value = data;
  posType.value = data.posTypeNameOld;
  posLevel.value = data.posLevelNameOld;
  position.value = data.positionOld;
  modalTree.value = true;
}

/** ยืนยันการบันทึกข้อมูลเลือกตำแหน่ง*/
async function onSave(data: FormDataAppoint) {
  const dataAppoint = {
    node: data.node,
    nodeId: data.nodeId,
    orgRevisionId: data.orgRevisionId,
    positionId: data.positionId,
    posMasterNo: data.posMasterNo,
    positionName: data.positionName,
    posTypeId: data.posTypeId,
    posTypeName: data.posTypeName,
    posLevelId: data.posLevelId,
    posLevelName: data.posLevelName,
    reportingDate: data.reportingDate,
    posmasterId: data.posmasterId,
    typeCommand: data.typeCommand,
  };
  showLoader();
  await http
    .put(config.API.appointmentPosition(personalId.value), dataAppoint)
    .then(async () => {
      await fecthlistappointment();
      await success($q, "บันทึกสำเร็จ");
      modalTree.value = false;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

async function onSearch() {
  rows.value = onSearchDataTable(
    filterKeyword.value,
    rowsData.value,
    columns.value ? columns.value : []
  );
}

onMounted(async () => {
  await fecthlistappointment();
});
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    รายการปรับระดับชั้นงาน-ย้ายลูกจ้าง
  </div>
  <q-card flat bordered class="col-12 q-mt-sm">
    <div class="row q-pa-md">
      <div class="col-12">
        <div class="row">
          <div class="col-2">
            <q-select
              :model-value="status ? status : 'ทั้งหมด'"
              outlined
              dense
              label="สถานะ"
              :options="store.statusOp"
              emit-value
              map-options
              option-label="name"
              option-value="id"
              fill-input
              use-input
              hide-selected
              bg-color="white"
              @filter="(inputValue:any,doneFn:Function) => filterOption(inputValue, doneFn) "
              @update:model-value="(value:string)=>{(status = value),fecthlistappointment()}"
            >
              <template v-slot:no-option>
                <q-item>
                  <q-item-section class="text-grey">
                    ไม่มีข้อมูล
                  </q-item-section>
                </q-item>
              </template>
              <template v-if="status" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop.prevent="(status = ''), fecthlistappointment()"
                  class="cursor-pointer"
                  style="opacity: 0.6"
                />
              </template>
            </q-select>
          </div>
          <q-btn
            v-if="
              checkPermission($route)?.attrIsUpdate &&
              checkPermissionList(['COMMAND']) &&
              checkPermissionCreate('COMMAND')
            "
            @click="popup()"
            size="14px"
            flat
            round
            color="primary"
            icon="mdi-account-arrow-right"
          >
            <q-tooltip>ส่งไปออกคำสั่ง</q-tooltip>
          </q-btn>

          <q-space />
          <q-input
            standout
            dense
            v-model="filterKeyword"
            ref="filterRef"
            outlined
            placeholder="ค้นหา"
            @keydown.enter.prevent="onSearch"
          >
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>

          <q-select
            v-model="visibleColumns"
            multiple
            outlined
            dense
            options-dense
            :display-value="$q.lang.table.columns"
            emit-value
            map-options
            :options="columns"
            option-value="name"
            style="min-width: 140px"
            class="q-ml-sm"
          />
        </div>

        <div class="col-12 q-pt-sm">
          <d-table
            :columns="columns"
            :rows="rows"
            row-key="id"
            :visible-columns="visibleColumns"
            v-model:pagination="pagination"
          >
            <template v-slot:header="props">
              <q-tr :props="props">
                <q-th auto-width />
                <q-th v-for="col in props.cols" :key="col.name" :props="props">
                  <span class="text-weight-medium">{{ col.label }}</span>
                </q-th>
              </q-tr>
            </template>
            <template v-slot:body="props">
              <q-tr :props="props">
                <q-td auto-width>
                  <q-btn
                    v-if="
                      (props.row.status !== 'REPORT' &&
                        props.row.status !== 'DONE' &&
                        checkPermission($route)?.attrIsGet) ||
                      (checkPermission($route)?.attrIsDelete &&
                        props.row.status !== 'REPORT' &&
                        props.row.status !== 'DONE') ||
                      (checkPermission($route)?.attrIsGet &&
                        checkPermission($route)?.attrIsDelete) ||
                      checkPermission($route)?.attrIsGet
                    "
                    icon="mdi-dots-horizontal-circle-outline"
                    color="secondary"
                    flat
                    round
                    dense
                  >
                    <q-menu
                      transition-show="jump-down"
                      transition-hide="jump-up"
                    >
                      <q-list dense style="min-width: 200px">
                        <q-item
                          v-if="
                            checkPermission($route)?.attrIsUpdate &&
                            checkPermission($route)?.attrIsGet &&
                            props.row.status !== 'REPORT' &&
                            props.row.status !== 'DONE'
                          "
                          clickable
                          v-close-popup
                          @click="openModalTree(props.row, 'SLIP')"
                        >
                          <q-item-section style="min-width: 0px" avatar>
                            <q-icon
                              color="primary"
                              size="xs"
                              name="mdi-bookmark-outline"
                            />
                          </q-item-section>
                          <q-item-section
                            >เลือกหน่วยงานที่รับปรับระดับชั้นงาน</q-item-section
                          >
                        </q-item>
                        <q-item
                          v-if="
                            checkPermission($route)?.attrIsUpdate &&
                            checkPermission($route)?.attrIsGet &&
                            props.row.status !== 'REPORT' &&
                            props.row.status !== 'DONE'
                          "
                          clickable
                          v-close-popup
                          @click="openModalTree(props.row, 'MOVE')"
                        >
                          <q-item-section style="min-width: 0px" avatar>
                            <q-icon
                              color="primary"
                              size="xs"
                              name="mdi-bookmark-outline"
                            />
                          </q-item-section>
                          <q-item-section
                            >เลือกหน่วยงานที่รับย้าย</q-item-section
                          >
                        </q-item>

                        <q-item
                          v-if="checkPermission($route)?.attrIsGet"
                          clickable
                          v-close-popup
                          @click="nextPage(props.row.id)"
                        >
                          <q-item-section style="min-width: 0px" avatar>
                            <q-icon color="info" size="xs" name="mdi-eye" />
                          </q-item-section>
                          <q-item-section>รายละเอียด</q-item-section>
                        </q-item>
                        <q-item
                          v-if="
                            checkPermission($route)?.attrIsDelete &&
                            props.row.status !== 'REPORT' &&
                            props.row.status !== 'DONE'
                          "
                          clickable
                          v-close-popup
                          @click="clickDelete(props.row.id)"
                        >
                          <q-item-section style="min-width: 0px" avatar>
                            <q-icon color="red" size="xs" name="mdi-delete" />
                          </q-item-section>
                          <q-item-section>ลบ</q-item-section>
                        </q-item>
                      </q-list>
                    </q-menu>
                  </q-btn>
                </q-td>
                <q-td v-for="col in props.cols" :key="col.name" :props="props">
                  <div v-if="col.name == 'no'">
                    {{ props.rowIndex + 1 }}
                  </div>

                  <div
                    v-else-if="col.name == 'organizationNameOld'"
                    class="text-html"
                  >
                    {{
                      props.row.organizationPositionOld !== null
                        ? props.row.organizationPositionOld
                        : "-"
                    }}
                  </div>

                  <div v-else-if="col.name == 'organizationName'">
                    {{ props.row.position !== null ? props.row.position : "" }}
                    {{
                      props.row.posLevelName !== null
                        ? `${props.row.posLevelName}`
                        : ""
                    }}
                    {{
                      props.row.nodeShortName !== null
                        ? `(${props.row.nodeShortName} ${props.row.posMasterNo})`
                        : ""
                    }}
                    <div class="text-html">
                      {{ findOrgNameHtml(props.row) }}
                    </div>
                  </div>

                  <div v-else>
                    {{ col.value ? col.value : "-" }}
                  </div>
                </q-td>
              </q-tr>
            </template>
          </d-table>
        </div>
      </div>
    </div>
  </q-card>

  <Dialogbody
    v-model:Modal="modal"
    v-model:filter-keyword2="filterKeyword2"
    v-model:type="type"
    :click-close="clickClose"
    :options-type="optionsType"
    :next-page="nextPage"
    :fetch-data="fecthlistappointment"
    v-model:rows="rows2"
    v-model:rowsData="rows2Data"
  />

  <DialogOrgSelectEmployee
    :title="`เลือกหน่วยงานที่รับ${
      typeModal !== 'MOVE' ? `การปรับระดับชั้นงาน` : `ย้าย`
    }`"
    v-model:modal="modalTree"
    v-model:type="typeModal"
    :pos-type="posType"
    :pos-level="posLevel"
    :position="position"
    :data-rows="dataRows"
    :onSubmit="onSave"
  />
</template>
<style scoped lang="scss"></style>
